/* FUNCTION list 	---	---	---	---	---	---	---
_AgiInit                         cseg     0000115C 00000057
_GameInit                        cseg     000011B3 0000012B
_RoomInit                        cseg     000012DE 00000015
*/

//~ RaDIaT1oN (2002-04-29):
//~ don't redirect console for linux
//~ definately credit radiation for his fine linux porting
//~ use setenv for setting environment under linux
//~ warning placement

/* BASE headers	---	---	---	---	---	---	--- */
#include "agi.h"
#include "initialise.h"

/* LIBRARY headers	---	---	---	---	---	---	--- */
#include <stdlib.h>
#include <stdio.h>
#include <string.h> 

/* OTHER headers	---	---	---	---	---	---	--- */
#include "sys/drv_video.h"
#include "sys/gfx.h"
#include "sys/glob_sys.h"
#include "picture/pic_res.h"
#include "game_id.h"
#include "flags.h"
#include "decrypt.h"
#include "res/res.h"
#include "logic/logic_base.h"
#include "picture/sbuf_util.h"
// for blists_erase
#include "view/obj_update.h"
#include "view/obj_base.h"
#include "view/view_base.h"
#include "sound/sound_base.h"
// words.tok.data
#include "ui/parse.h"
// event_init
#include "ui/events.h"
// controller
#include "ui/controller.h"
// text colour
#include "ui/agi_text.h"
// input_redraw
#include "ui/cmd_input.h"
// byte-order support
#include "sys/endian.h"
#include "objects.h"
#include "sys/time.h"

#include "logic/cmd_table.h"
#include "ui/mouse.h"

#include "sys/ini_config.h"
#include "config.h"

#include "sys/sys_dir.h"

#include "sound/sound_gen.h"
#include "base.h"
#include "sys/mem_wrap.h"

#include "log.h"

/* PROTOTYPES	---	---	---	---	---	---	--- */
// reads ini file and inits nagi
void nagi_init(void);
// after reading the version, inits this particular version of agi
void agi_init(void);
// for a new game.. can be called later by restart/restore
void game_init(void);
// refresh lists for new room
void room_init(void);




/* VARIABLES	---	---	---	---	---	---	--- */


/* CODE	---	---	---	---	---	---	---	--- */


void nagi_init()
{	
#ifndef RAD_LINUX
	u8 env_value[50];
#endif
	INI *ini_nagi;

#ifdef _VC7
	//need to manually assign default stuff
	config_nagi[0].key = "log_debug";
	config_nagi[0].section = "nagi";
	config_nagi[0].type = CT_BOOL;
	config_nagi[0].b.ptr = &c_nagi_log_debug;
	config_nagi[0].b.def = 0;

	config_nagi[1].key = "console";
	config_nagi[1].section = 0;
	config_nagi[1].type = CT_BOOL;
	config_nagi[1].b.ptr = &c_nagi_console;
	config_nagi[1].b.def = 1;

	config_nagi[2].key = "font_benchmark";
	config_nagi[2].section = 0;
	config_nagi[2].type = CT_BOOL;
	config_nagi[2].b.ptr = &c_nagi_font_benchmark;
	config_nagi[2].b.def = 0;

	config_nagi[3].key = "crc_print";
	config_nagi[3].section = 0;
	config_nagi[3].type = CT_BOOL;
	config_nagi[3].b.ptr = &c_nagi_crc_print;
	config_nagi[3].b.def = 0;

	config_nagi[4].key = "dir_list";
	config_nagi[4].section = 0;
	config_nagi[4].type = CT_STRING;
	config_nagi[4].s.ptr = &c_nagi_dir_list;
	config_nagi[4].s.def = ".";

	config_nagi[5].key = "sort";
	config_nagi[5].section = 0;
	config_nagi[5].type = CT_STRING;
	config_nagi[5].s.ptr = &c_nagi_sort;
	config_nagi[5].s.def = "alpha";

	config_nagi[6].key = "driver";
	config_nagi[6].section = "vid";
	config_nagi[6].type = CT_STRING;
	config_nagi[6].s.ptr = &c_vid_driver;
	config_nagi[6].s.def = "sdl";

	config_nagi[7].key = "scale";
	config_nagi[7].section = 0;
	config_nagi[7].type = CT_INT;
	config_nagi[7].i.ptr = &c_vid_scale;
	config_nagi[7].i.def = 2;
	config_nagi[7].i.min = 1;
	config_nagi[7].i.max = -1;

	config_nagi[8].key = "full_screen";
	config_nagi[8].section = 0;
	config_nagi[8].type = CT_BOOL;
	config_nagi[8].b.ptr = &c_vid_full_screen;
	config_nagi[8].b.def = 0;

	config_nagi[9].key = "renderer";
	config_nagi[9].section = 0;
	config_nagi[9].type = CT_STRING;
	config_nagi[9].s.ptr = &c_vid_renderer;
	config_nagi[9].s.def = "ega";

	config_nagi[10].key = "pal_16";
	config_nagi[10].section = 0;
	config_nagi[10].type = CT_STRING;
	config_nagi[10].s.ptr = &c_vid_pal_16;
	config_nagi[10].s.def = "pal_16.pal";

	config_nagi[11].key = "pal_text";
	config_nagi[11].section = 0;
	config_nagi[11].type = CT_STRING;
	config_nagi[11].s.ptr = &c_vid_pal_text;
	config_nagi[11].s.def = "pal_text.pal";

	config_nagi[12].key = "pal_cga0";
	config_nagi[12].section = 0;
	config_nagi[12].type = CT_STRING;
	config_nagi[12].s.ptr = &c_vid_pal_cga0;
	config_nagi[12].s.def = "pal_cga0.pal";

	config_nagi[13].key = "pal_cga1";
	config_nagi[13].section = 0;
	config_nagi[13].type = CT_STRING;
	config_nagi[13].s.ptr = &c_vid_pal_cga1;
	config_nagi[13].s.def = "pal_cga1.pal";

	config_nagi[14].key = "pal_bw";
	config_nagi[14].section = 0;
	config_nagi[14].type = CT_STRING;
	config_nagi[14].s.ptr = &c_vid_pal_bw;
	config_nagi[14].s.def = "pal_bw.pal";

	config_nagi[15].key = "fonts_bitmap";
	config_nagi[15].section = 0;
	config_nagi[15].type = CT_STRING;
	config_nagi[15].s.ptr = &c_vid_fonts_bitmap;
	config_nagi[15].s.def = "font_4x8_ext.nbf;font_8x8_ext.nbf;font_16x16_ext.nbf";

	config_nagi[16].key = "fonts_vector";
	config_nagi[16].section = 0;
	config_nagi[16].type = CT_STRING;
	config_nagi[16].s.ptr = &c_vid_fonts_vector;
	config_nagi[16].s.def = "none.nvf";

	config_nagi[17].key = "driver";
	config_nagi[17].section = "snd";
	config_nagi[17].type = CT_STRING;
	config_nagi[17].s.ptr = &c_snd_driver;
	config_nagi[17].s.def = "sdl";

	config_nagi[18].key = "enable";
	config_nagi[18].section = 0;
	config_nagi[18].type = CT_BOOL;
	config_nagi[18].b.ptr = &c_snd_enable;
	config_nagi[18].b.def = 1;

	config_nagi[19].key = "single"; 
	config_nagi[19].section = 0;
	config_nagi[19].type = CT_BOOL;
	config_nagi[19].b.ptr = &c_snd_single;
	config_nagi[19].b.def = 0;

	config_nagi[20].key = "dissolve";
	config_nagi[20].section = 0;
	config_nagi[20].type = CT_INT;
	config_nagi[20].i.ptr = &c_snd_dissolve;
	config_nagi[20].i.def = 3;
	config_nagi[20].i.min = 0;
	config_nagi[20].i.max = 3;

	config_nagi[21].key = "read_var";
	config_nagi[21].section = 0;
	config_nagi[21].type = CT_BOOL;
	config_nagi[21].b.ptr = &c_snd_read_var;
	config_nagi[21].b.def = 0;

	config_nagi[22].key = "volume"; 
	config_nagi[22].section = 0;
	config_nagi[22].type = CT_INT;
	config_nagi[22].i.ptr = &c_snd_volume;
	config_nagi[22].i.def = 0x7FFF;
	config_nagi[22].i.min = 0;
	config_nagi[22].i.max = 0x7FFF;

	config_nagi[23].key = "drv_video"; 
	config_nagi[23].section = "sdl";
	config_nagi[23].type = CT_STRING;
	config_nagi[23].s.ptr = &c_sdl_drv_video;
	config_nagi[23].s.def = "directx";

	config_nagi[24].key = "drv_sound";
	config_nagi[24].section = 0;
	config_nagi[24].type = CT_STRING;
	config_nagi[24].s.ptr = &c_sdl_drv_sound;
	config_nagi[24].s.def = "waveout";

	config_nagi[25].key = "colour0"; //black
	config_nagi[25].section = "palette";
	config_nagi[25].type = CT_STRING;
	config_nagi[25].s.ptr = &c_palette_colour[0];
	config_nagi[25].s.def = "0x00,0x00,0x00";

	config_nagi[26].key = "colour1"; //dark blue
	config_nagi[26].section = 0;
	config_nagi[26].type = CT_STRING;
	config_nagi[26].s.ptr = &c_palette_colour[1];
	config_nagi[26].s.def = "0x00,0x00,0xAA";

	config_nagi[27].key = "colour2"; //dark green
	config_nagi[27].section = 0;
	config_nagi[27].type = CT_STRING;
	config_nagi[27].s.ptr = &c_palette_colour[2];
	config_nagi[27].s.def = "0x00,0xAA,0x00";

	config_nagi[28].key = "colour3"; //dark cyan
	config_nagi[28].section = 0;
	config_nagi[28].type = CT_STRING;
	config_nagi[28].s.ptr = &c_palette_colour[3];
	config_nagi[28].s.def = "0x00,0xAA,0xAA";

	config_nagi[29].key = "colour4"; //dark red
	config_nagi[29].section = 0;
	config_nagi[29].type = CT_STRING;
	config_nagi[29].s.ptr = &c_palette_colour[4];
	config_nagi[29].s.def = "0xAA,0x00,0x00";

	config_nagi[30].key = "colour5"; //dark purple
	config_nagi[30].section = 0;
	config_nagi[30].type = CT_STRING;
	config_nagi[30].s.ptr = &c_palette_colour[5];
	config_nagi[30].s.def = "0xAA,0x00,0xAA";

	config_nagi[31].key = "colour6"; //dark brown
	config_nagi[31].section = 0;
	config_nagi[31].type = CT_STRING;
	config_nagi[31].s.ptr = &c_palette_colour[6];
	config_nagi[31].s.def = "0xAA,0x55,0x00";

	config_nagi[32].key = "colour7"; //light grey
	config_nagi[32].section = 0;
	config_nagi[32].type = CT_STRING;
	config_nagi[32].s.ptr = &c_palette_colour[7];
	config_nagi[32].s.def = "0xAA,0xAA,0xAA";

	config_nagi[33].key = "colour8"; //dark grey
	config_nagi[33].section = 0;
	config_nagi[33].type = CT_STRING;
	config_nagi[33].s.ptr = &c_palette_colour[8];
	config_nagi[33].s.def = "0x55,0x55,0x55";

	config_nagi[34].key = "colour9"; //light blue
	config_nagi[34].section = 0;
	config_nagi[34].type = CT_STRING;
	config_nagi[34].s.ptr = &c_palette_colour[9];
	config_nagi[34].s.def = "0x55,0x55,0xFF";

	config_nagi[35].key = "colour10"; //light green
	config_nagi[35].section = 0;
	config_nagi[35].type = CT_STRING;
	config_nagi[35].s.ptr = &c_palette_colour[10];
	config_nagi[35].s.def = "0x55,0xFF,0x55";

	config_nagi[36].key = "colour11"; //light cyan
	config_nagi[36].section = 0;
	config_nagi[36].type = CT_STRING;
	config_nagi[36].s.ptr = &c_palette_colour[11];
	config_nagi[36].s.def = "0x55,0xFF,0xFF";

	config_nagi[37].key = "colour12"; //light red
	config_nagi[37].section = 0;
	config_nagi[37].type = CT_STRING;
	config_nagi[37].s.ptr = &c_palette_colour[12];
	config_nagi[37].s.def = "0xFF,0x55,0x55";

	config_nagi[38].key = "colour13"; //light purple
	config_nagi[38].section = 0;
	config_nagi[38].type = CT_STRING;
	config_nagi[38].s.ptr = &c_palette_colour[13];
	config_nagi[38].s.def = "0xFF,0xAA,0xAA";

	config_nagi[39].key = "colour14"; //light yellow
	config_nagi[39].section = 0;
	config_nagi[39].type = CT_STRING;
	config_nagi[39].s.ptr = &c_palette_colour[14];
	config_nagi[39].s.def = "0xFF,0xFF,0x55";

	config_nagi[40].key = "colour15"; //white
	config_nagi[40].section = 0;
	config_nagi[40].type = CT_STRING;
	config_nagi[40].s.ptr = &c_palette_colour[15];
	config_nagi[40].s.def = "0xFF,0xFF,0xFF";

	config_nagi[41].key =  0;

	// for use in standard.ini
	config_standard[0].key = "crc_list"; 
	config_standard[0].section = "standard";
	config_standard[0].type = CT_STRING;
	config_standard[0].s.ptr = &c_standard_crc_list;
	config_standard[0].s.def = "none";

	config_standard[1].key = "agi_list";
	config_standard[1].section = 0;
	config_standard[1].type = CT_STRING;
	config_standard[1].s.ptr = &c_standard_agi_list;
	config_standard[1].s.def = "pc_2_936;pc_3_002_149;amiga_2;amiga_3";

	config_standard[2].key = "force"; 
	config_standard[2].section = 0;
	config_standard[2].type = CT_STRING;
	config_standard[2].s.ptr = &c_standard_force;
	config_standard[2].s.def = "not defined";

	config_standard[3].key = "v2_default"; 
	config_standard[3].section = 0;
	config_standard[3].type = CT_STRING;
	config_standard[3].s.ptr = &c_standard_v2_default;
	config_standard[3].s.def = "pc_2_936";

	config_standard[4].key = "v3_default";
	config_standard[4].section = 0;
	config_standard[4].type = CT_STRING;
	config_standard[4].s.ptr = &c_standard_v3_default;
	config_standard[4].s.def = "pc_3_002_149";

	config_standard[5].key = "amiga_v2_default";
	config_standard[5].section = 0;
	config_standard[5].type = CT_STRING;
	config_standard[5].s.ptr = &c_standard_amiga_v2_default;
	config_standard[5].s.def = "amiga_2";

	config_standard[6].key = "amiga_v3_default";
	config_standard[6].section = 0;
	config_standard[6].type = CT_STRING;
	config_standard[6].s.ptr = &c_standard_amiga_v3_default;
	config_standard[6].s.def = "amiga_3";

	config_standard[7].key =  0;

	// for use in standard.ini after a game section has been set.
	config_game[0].key = "version_info";
	config_game[0].section = 0;
	config_game[0].type = CT_STRING;
	config_game[0].s.ptr = &c_game_version_info;
	config_game[0].s.def = 0;

	config_game[1].key = "mouse";
	config_game[1].section = 0;
	config_game[1].type = CT_INT;
	config_game[1].i.ptr = &c_game_mouse;
	config_game[1].i.def = 0;
	config_game[1].i.min = 0;
	config_game[1].i.max = 20;

	config_game[2].key = "loop_update";
	config_game[2].section = 0;
	config_game[2].type = CT_INT;
	config_game[2].i.ptr = &c_game_loop_update;
	config_game[2].i.def = 0;
	config_game[2].i.min = 0;
	config_game[2].i.max = 4;

	config_game[3].key = "id";
	config_game[3].section = 0;
	config_game[3].type = CT_STRING;
	config_game[3].s.ptr = &c_game_id;
	config_game[3].s.def = 0;
		
	config_game[4].key = "object_decrypt";
	config_game[4].section = 0;
	config_game[4].type = CT_BOOL;
	config_game[4].b.ptr = &c_game_object_decrypt;
	config_game[4].b.def = 1;

	config_game[5].key = "object_packed";
	config_game[5].section = 0;
	config_game[5].type = CT_BOOL;
	config_game[5].b.ptr = &c_game_object_packed;
	config_game[5].b.def = 0;

	config_game[6].key = "compression";
	config_game[6].section = 0;
	config_game[6].type = CT_BOOL;
	config_game[6].b.ptr = &c_game_compression;
	config_game[6].b.def = 0;

	config_game[7].key = "dir_type";
	config_game[7].section = 0;
	config_game[7].type = CT_INT;
	config_game[7].b.ptr = &c_game_dir_type;
	config_game[7].b.def = 1;
	config_game[7].i.min = 0;
	config_game[7].i.max = 3;

	config_game[8].key = 0;
#endif

	memset( &state, 0, sizeof(AGI_STATE) );
	state.word_13f = 0x0F;
	state.script_size = 0x32;
	state.input_pos = 0x17;
	state.status_line_row = 0x15;
	state.menu_state = 1;
	computer_type = 0;	// ibm pc
	drives_found = 1;	// yes, drives are known of
	display_type = 0;		// ega
	//text_mode = 0;

	// read nagi.ini
	dir_preset_change(DIR_PRESET_NAGI);
	ini_nagi = ini_open("nagi.ini");
	config_load(config_nagi, ini_nagi);
	ini_close(ini_nagi);

	//initialize colour palette
	gfx_palette_init();

	// for the console window thingy
#ifndef RAD_LINUX
	if (c_nagi_console)
	{
		freopen("CON", "w", stdout);
		freopen("CON", "w", stderr);
	}
#endif

	printf("New Adventure Game Interpreter (NAGI) %s\n", NAGI_VERSION);
	printf("Copyright (C) 2000-2002 Nick Sonneveld & Gareth McMullin\n");
	printf("Author: Nick Sonneveld (sonneveld@hotmail.com)\n");
	printf("Linux port by RaDIaT1oN (g_mcm@mweb.co.za)\n");
	printf("VS.NET port by Andrew Korson\n\n");
	
	printf("Based upon the Adventure Game Interpreter (AGI) v2.917 and v3.002.149\n");
	printf("Copyright (C) 1984-1988 Sierra On-Line, Inc.\n");
	printf("Authors: Jeff Stephenson & Chris Iden\n\n");

	// initialise SDL
	printf("Initialising Simple DirectMedia Layer (SDL)...");

	// setting environment vars is touchy...
#ifdef NAGI_SDLENV
	// video_dirver
	if (strlen(c_sdl_drv_video) > 30)
		c_sdl_drv_video[30] = 0;
	if (strlen(c_sdl_drv_sound) > 30)
		c_sdl_drv_sound[30] = 0;

#ifndef RAD_LINUX
	sprintf(env_value, "SDL_VIDEODRIVER=%s", c_sdl_drv_video);
	putenv(env_value);
	// audio driver
	sprintf(env_value, "SDL_AUDIODRIVER=%s", c_sdl_drv_sound);
	putenv(env_value);
#else	
	if(c_sdl_drv_video[0]) 
		setenv("SDL_VIDEODRIVER", c_sdl_drv_video, 1);

	if(c_sdl_drv_sound[0])
		setenv("SDL_AUDIODRIVER", c_sdl_drv_sound, 1);
#endif
	
#endif

	//SDL_INIT_EVENTTHREAD SDL_INIT_AUDIO|
	if ( SDL_Init(SDL_INIT_TIMER) < 0 )
	{
		printf("Unable to init SDL: %s\n", SDL_GetError());
		exit(1);
	}
	atexit(SDL_Quit);
	printf("done.\n");
	
	gfx_init();
	
	// clear keyboard input
	//clear_input();
#ifndef _VC7
#warning keyboard needs a bit of cleanup
#endif
	events_init();
	
	//load_vectors();	// keyboard, timer, critical error
	
	// call do_clock at 20Hz.
	clock_init();
	sndgen_init();
	
	/*
	input_init();	// inits joystick
	*/
	text_colour(15, 0);
	input_redraw();
	
	// allocate memory for the LZW dictionary
	lzw_dict = malloc(0x800 * sizeof(DICT));
}

void agi_init()
{
	// initialise any function changes from the norm 
	// quit 0-1 param
	
	// cmd171 for brian mouse support

		
	// printat support
	
	// cmd176 if it's EVER used
	
	mouse_init();
	
	/* load directories for the various resources */
	/* logics, pictures, views, sound */
	dir_load();
	
	dir_preset_change(DIR_PRESET_GAME);
	words_tok_data = file_load("words.tok", 0);
	
	logic_list_init();
	view_list_init();
	sound_list_init();
	pic_list_init();

	game_init();	
	
	logic_load_2(0);
	//_SetMemRm0();	// pointer to data AFTER loaded logic 0

	flag_set(9);	// turn sound on
}

void game_init(void)
{
	if (object_file_load())
		agi_exit();
	memset(state.var, 0, sizeof(state.var));	// clear variables
	flags_clear();
	control_state_clear();
	room_init();				// reset file data stuff to 0
	blists_erase();

	state.var[V20_COMPUTER] = computer_type;
	state.var[V26_MONITORTYPE] = display_type;
	state.var[V24_INPUTLEN] = 0x29;
	state.var[V08_FREEMEM] = 10;
	
	flag_set(F05_NEWROOM);			// first time in room.

	state.ego_control_state = 1;
	state.pic_num = 0;				// used in drawPic (dseg:13b)
	state.block_state = 0;				// a block is not set

	if (computer_type == 0)
		state.var[V22_SNDTYPE] = 1;	// pc
	else
	{
		state.var[V22_SNDTYPE] = 3;	// tandy
		flag_set(F11_NEWLOGIC0);		// logic 0 executed for first time.
	}
}

void room_init(void)
{
	logic_list_new_room();
	view_list_new_room();
	sound_list_new_room();
	pic_list_new_room();
}


void agi_shutdown(void)
{
	// anything opened/alloced in game_init and during the game
	
	// object_free
	object_file_unload();
	
	// blists free
	blists_free();
	
	// log file
	//close_log_file();
	
	// menus
	// res
	// window name
	// TODO
	
	// the agi info that is init'd every game
	
	//pic_list_free();
	view_list_free();
	//logic_list_free();
	//sound_list_free();
	
	// words.tok free
	a_free(words_tok_data);
	words_tok_data = 0;
	
	// dir_load free
	dir_unload();
	
	// mouse shutdown
	mouse_shutdown();
	
	log_close();
}

void nagi_shutdown(void)
{
	// lzw dict
	free(lzw_dict);
	lzw_dict = 0;

	//sound_shutdown
	sndgen_shutdown();
	// clock_shutdown
	clock_denit();

	// events_shutdown
	// TODO during events rewrite
	
	// gfx_shutdown
	gfx_shutdown();
	
	// sdl_shutdown
	SDL_Quit();
	
	// console close
	// config write
	// TODO
}
